Index: include/libroar/vs.h
===================================================================
--- include/libroar/vs.h	(revision 4580)
+++ include/libroar/vs.h	(revision 4605)
@@ -30,5 +30,5 @@
  *  or libpulse*:
  *  The libs libroaresd, libroararts and libroarpulse link this lib
- *  and are therefore GPL. Because of this it may be illigal to use
+ *  and are therefore GPL. Because of this it may be illegal to use
  *  them with any software that uses libesd, libartsc or libpulse*.
  */
@@ -44,5 +44,5 @@
 typedef signed long int roar_mus_t;
 
-/* return readable string descriping the problem */
+/* return readable string describing the problem */
 const char * roar_vs_strerr(int error);
 
@@ -60,5 +60,5 @@
 
 /* connect to server and start stream in once
- * this is basicly roar_vs_new() and roar_vs_stream() in one function.
+ * this is basically roar_vs_new() and roar_vs_stream() in one function.
  */
 roar_vs_t * roar_vs_new_simple(const char * server, const char * name, int rate, int channels, int codec, int bits, int dir, int * error);
@@ -95,5 +95,5 @@
  * This does all needed cleanup.
  * If server connection was made by VS it is closed, too.
- * If server connectionw as provided by caller it is untouched.
+ * If server connection was provided by caller it is untouched.
  */
 int roar_vs_close(roar_vs_t * vss, int killit, int * error);
@@ -102,8 +102,8 @@
  * This function writes some data to the stream.
  * return is number of bytes written or -1 on error.
- * return value can be zero to intercate no data can be written but no error.
+ * return value can be zero to indicate no data can be written but no error.
  * this may be the case with non-blocking streams.
- * retruned value can be less then requested value. indecates a short write.
- * you should wait some (short!) time (for example one main loop interation) and try again.
+ * returned value can be less then requested value. indicates a short write.
+ * you should wait some (short!) time (for example one main loop iteration) and try again.
  */
 ssize_t roar_vs_write(roar_vs_t * vss, const void * buf, size_t len, int * error);
@@ -112,8 +112,8 @@
  * This function reads some data from the stream.
  * return is number of bytes read or -1 on error.
- * return value can be zero to intercate no data can be read but no error.
+ * return value can be zero to indicate no data can be read but no error.
  * this may be the case with non-blocking streams.
- * retruned value can be less then requested value. indecates a short read.
- * you should wait some (short!) time (for example one main loop interation) and try again.
+ * returned value can be less then requested value. indicates a short read.
+ * you should wait some (short!) time (for example one main loop iteration) and try again.
  */
 ssize_t roar_vs_read (roar_vs_t * vss,       void * buf, size_t len, int * error);
@@ -138,12 +138,12 @@
 /* do not supply backend offset */
 #define ROAR_VS_BACKEND_NONE    -1
-/* use first found primay stream of same mixer as offset source */
+/* use first found primary stream of same mixer as offset source */
 #define ROAR_VS_BACKEND_FIRST   -2
 /* use mean of primary streams of same mixer as offset source */
 #define ROAR_VS_BACKEND_MEAN    -3
 
-/* get server's possition of stream
- * returns server's possition of the stream or -1 on error.
- * The retruned server possition is the possition in samples
+/* get server's position of stream
+ * returns server's position of the stream or -1 on error.
+ * The returned server position is the position in samples
  * plus a offset provided by the selected backend
  */
@@ -153,9 +153,9 @@
  * This function may fail because the used codec uses
  * non-fixed bitrate.
- * if this function fails it retruns zero and sets error or
+ * if this function fails it returns zero and sets error or
  * clear error to ROAR_ERROR_NONE.
- * If non-zero is retruned error is untouched.
+ * If non-zero is returned error is untouched.
  * return value is in mu-sec (units of 10^-6s).
- * Note that the retruned value may be negative (the server being
+ * Note that the returned value may be negative (the server being
  * ahead of us). This is normal in case we read a stream.
  */
@@ -163,16 +163,16 @@
 
 /* set pause flag
- * The pause flag should be set whenever the user presses the pause button or simular.
+ * The pause flag should be set whenever the user presses the pause button or similar.
  * The stream may be come blocking after the pause flag has been set.
- * returns old pause setting (usefull with ROAR_VS_TOGGLE)
+ * returns old pause setting (useful with ROAR_VS_TOGGLE)
  */
 int     roar_vs_pause(roar_vs_t * vss, int val, int * error);
 
 /* set the mute flag of the stream
- * Thie pause flag should be set wehnever the user mutes the stream in some way.
+ * The pause flag should be set whenever the user mutes the stream in some way.
  * This flag is used so the volume is not changed and can be restored by the server
  * while unmuting.
  * It is very recommended to use this flag and not just set the volume to zero
- * returns old mute setting (usefull with ROAR_VS_TOGGLE)
+ * returns old mute setting (useful with ROAR_VS_TOGGLE)
  */
 int     roar_vs_mute (roar_vs_t * vss, int val, int * error);
@@ -183,5 +183,5 @@
  */
 int     roar_vs_volume_mono   (roar_vs_t * vss, float c, int * error);
-/* set volume of stream (like volume + ballance, stereo mode)
+/* set volume of stream (like volume + balance, stereo mode)
  * volume l and r are floats from 0 ('muted', see above) to 1 (full volume).
  * Returns 0 on no error and -1 on error.
@@ -189,6 +189,6 @@
 int     roar_vs_volume_stereo (roar_vs_t * vss, float l, float r, int * error);
 
-/* get volume from stream (like volume + ballance, stereo mode)
- * volume pinters l and r are floats from 0 ('muted', see above) to 1 (full volume).
+/* get volume from stream (like volume + balance, stereo mode)
+ * volume pointers l and r are floats from 0 ('muted', see above) to 1 (full volume).
  * Returns 0 on no error and -1 on error.
  * NOTE: if you want a 'mono' volume (like roar_vs_volume_mono() takes)
@@ -215,5 +215,5 @@
 int     roar_vs_role          (roar_vs_t * vss, int role, int * error);
 
-/* Run a single interation.
+/* Run a single iteration.
  * This will try to read data from source, write it to the stream
  * and flush the buffer in buffered mode.
@@ -222,5 +222,5 @@
 int     roar_vs_iterate       (roar_vs_t * vss, int wait, int * error);
 
-/* Iterate untill EOF or error.
+/* Iterate until EOF or error.
  * Very simple main loop.
  * Returns 0 on no error and -1 on error.
@@ -229,5 +229,5 @@
 
 /* Get used connection object
- * This may be usefull if you want to use functions from the main API.
+ * This may be useful if you want to use functions from the main API.
  * Returns used connection object or NULL on error.
  */
@@ -235,5 +235,5 @@
 
 /* Get used stream object
- * This may be usefull if you want to use functions from the main API.
+ * This may be useful if you want to use functions from the main API.
  * Returns used stream object or NULL on error.
  */
@@ -241,5 +241,5 @@
 
 /* Get used VIO object
- * This may be usefull if you want to use functions from the main API.
+ * This may be useful if you want to use functions from the main API.
  * For example this can be used in non-blocking mode
  * to test if we can read or write. To test that use roar_vio_select().
@@ -250,5 +250,5 @@
 /* send NOOP command to server
  * This can be used to ping the server.
- * This is of no use normaly.
+ * This is of no use normally.
  * Returns 0 on no error and -1 on error.
  */