Index: include/libroar/acl.h
===================================================================
--- include/libroar/acl.h	(revision 3810)
+++ include/libroar/acl.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/asyncctl.h
===================================================================
--- include/libroar/asyncctl.h	(revision 4341)
+++ include/libroar/asyncctl.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/auth.h
===================================================================
--- include/libroar/auth.h	(revision 4470)
+++ include/libroar/auth.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/authfile.h
===================================================================
--- include/libroar/authfile.h	(revision 4623)
+++ include/libroar/authfile.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/base64.h
===================================================================
--- include/libroar/base64.h	(revision 4588)
+++ include/libroar/base64.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/basic.h
===================================================================
--- include/libroar/basic.h	(revision 3914)
+++ include/libroar/basic.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/beep.h
===================================================================
--- include/libroar/beep.h	(revision 4097)
+++ include/libroar/beep.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/buffer.h
===================================================================
--- include/libroar/buffer.h	(revision 4629)
+++ include/libroar/buffer.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/caps.h
===================================================================
--- include/libroar/caps.h	(revision 4502)
+++ include/libroar/caps.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/cdrom.h
===================================================================
--- include/libroar/cdrom.h	(revision 3810)
+++ include/libroar/cdrom.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/client.h
===================================================================
--- include/libroar/client.h	(revision 4326)
+++ include/libroar/client.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/config.h
===================================================================
--- include/libroar/config.h	(revision 4653)
+++ include/libroar/config.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/crc.h
===================================================================
--- include/libroar/crc.h	(revision 4671)
+++ include/libroar/crc.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/crypto.h
===================================================================
--- include/libroar/crypto.h	(revision 4454)
+++ include/libroar/crypto.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/ctl.h
===================================================================
--- include/libroar/ctl.h	(revision 4614)
+++ include/libroar/ctl.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/debug.h
===================================================================
--- include/libroar/debug.h	(revision 3854)
+++ include/libroar/debug.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/display.h
===================================================================
--- include/libroar/display.h	(revision 3632)
+++ include/libroar/display.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/enumdev.h
===================================================================
--- include/libroar/enumdev.h	(revision 4355)
+++ include/libroar/enumdev.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/env.h
===================================================================
--- include/libroar/env.h	(revision 3958)
+++ include/libroar/env.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/error.h
===================================================================
--- include/libroar/error.h	(revision 4185)
+++ include/libroar/error.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/file.h
===================================================================
--- include/libroar/file.h	(revision 3810)
+++ include/libroar/file.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/hash.h
===================================================================
--- include/libroar/hash.h	(revision 4670)
+++ include/libroar/hash.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/hash_tiger.h
===================================================================
--- include/libroar/hash_tiger.h	(revision 4669)
+++ include/libroar/hash_tiger.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/keyval.h
===================================================================
--- include/libroar/keyval.h	(revision 3974)
+++ include/libroar/keyval.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/libroar.h
===================================================================
--- include/libroar/libroar.h	(revision 4597)
+++ include/libroar/libroar.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008, 2009, 2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/ltm.h
===================================================================
--- include/libroar/ltm.h	(revision 4295)
+++ include/libroar/ltm.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/memmgr.h
===================================================================
--- include/libroar/memmgr.h	(revision 4249)
+++ include/libroar/memmgr.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/meta.h
===================================================================
--- include/libroar/meta.h	(revision 4296)
+++ include/libroar/meta.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/nnode.h
===================================================================
--- include/libroar/nnode.h	(revision 3811)
+++ include/libroar/nnode.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/notify.h
===================================================================
--- include/libroar/notify.h	(revision 4339)
+++ include/libroar/notify.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/notify_proxy.h
===================================================================
--- include/libroar/notify_proxy.h	(revision 4314)
+++ include/libroar/notify_proxy.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/passwordapi.h
===================================================================
--- include/libroar/passwordapi.h	(revision 4466)
+++ include/libroar/passwordapi.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/pinentry.h
===================================================================
--- include/libroar/pinentry.h	(revision 3810)
+++ include/libroar/pinentry.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/random.h
===================================================================
--- include/libroar/random.h	(revision 4676)
+++ include/libroar/random.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/roardl.h
===================================================================
--- include/libroar/roardl.h	(revision 4681)
+++ include/libroar/roardl.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/roarfeatures.h
===================================================================
--- include/libroar/roarfeatures.h	(revision 4675)
+++ include/libroar/roarfeatures.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/roarfloat.h
===================================================================
--- include/libroar/roarfloat.h	(revision 4525)
+++ include/libroar/roarfloat.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/roarslp.h
===================================================================
--- include/libroar/roarslp.h	(revision 4414)
+++ include/libroar/roarslp.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/roarx11.h
===================================================================
--- include/libroar/roarx11.h	(revision 4084)
+++ include/libroar/roarx11.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/serverinfo.h
===================================================================
--- include/libroar/serverinfo.h	(revision 4441)
+++ include/libroar/serverinfo.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/simple.h
===================================================================
--- include/libroar/simple.h	(revision 3517)
+++ include/libroar/simple.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/socket.h
===================================================================
--- include/libroar/socket.h	(revision 4668)
+++ include/libroar/socket.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/sshaskpass.h
===================================================================
--- include/libroar/sshaskpass.h	(revision 3810)
+++ include/libroar/sshaskpass.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/stack.h
===================================================================
--- include/libroar/stack.h	(revision 3810)
+++ include/libroar/stack.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/stream.h
===================================================================
--- include/libroar/stream.h	(revision 4621)
+++ include/libroar/stream.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/vio.h
===================================================================
--- include/libroar/vio.h	(revision 4532)
+++ include/libroar/vio.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/vio_bio.h
===================================================================
--- include/libroar/vio_bio.h	(revision 3810)
+++ include/libroar/vio_bio.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/vio_buffer.h
===================================================================
--- include/libroar/vio_buffer.h	(revision 3970)
+++ include/libroar/vio_buffer.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/vio_buffer_store.h
===================================================================
--- include/libroar/vio_buffer_store.h	(revision 3994)
+++ include/libroar/vio_buffer_store.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/vio_cmd.h
===================================================================
--- include/libroar/vio_cmd.h	(revision 3811)
+++ include/libroar/vio_cmd.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/vio_ctl.h
===================================================================
--- include/libroar/vio_ctl.h	(revision 4705)
+++ include/libroar/vio_ctl.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/vio_dstr.h
===================================================================
--- include/libroar/vio_dstr.h	(revision 3517)
+++ include/libroar/vio_dstr.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/vio_jumbo.h
===================================================================
--- include/libroar/vio_jumbo.h	(revision 3811)
+++ include/libroar/vio_jumbo.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/vio_magic.h
===================================================================
--- include/libroar/vio_magic.h	(revision 4516)
+++ include/libroar/vio_magic.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/vio_ops.h
===================================================================
--- include/libroar/vio_ops.h	(revision 3811)
+++ include/libroar/vio_ops.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/vio_pipe.h
===================================================================
--- include/libroar/vio_pipe.h	(revision 3811)
+++ include/libroar/vio_pipe.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/vio_proto.h
===================================================================
--- include/libroar/vio_proto.h	(revision 4582)
+++ include/libroar/vio_proto.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/vio_rtp.h
===================================================================
--- include/libroar/vio_rtp.h	(revision 3517)
+++ include/libroar/vio_rtp.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/vio_select.h
===================================================================
--- include/libroar/vio_select.h	(revision 3767)
+++ include/libroar/vio_select.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/vio_socket.h
===================================================================
--- include/libroar/vio_socket.h	(revision 3811)
+++ include/libroar/vio_socket.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/vio_stack.h
===================================================================
--- include/libroar/vio_stack.h	(revision 3811)
+++ include/libroar/vio_stack.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/vio_stdio.h
===================================================================
--- include/libroar/vio_stdio.h	(revision 3517)
+++ include/libroar/vio_stdio.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/vio_stdvios.h
===================================================================
--- include/libroar/vio_stdvios.h	(revision 4534)
+++ include/libroar/vio_stdvios.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/vio_string.h
===================================================================
--- include/libroar/vio_string.h	(revision 3517)
+++ include/libroar/vio_string.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/vio_tantalos.h
===================================================================
--- include/libroar/vio_tantalos.h	(revision 3517)
+++ include/libroar/vio_tantalos.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/vio_winsock.h
===================================================================
--- include/libroar/vio_winsock.h	(revision 3517)
+++ include/libroar/vio_winsock.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/vs.h
===================================================================
--- include/libroar/vs.h	(revision 4640)
+++ include/libroar/vs.h	(revision 4708)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2011
  *
  *  This file is part of libroar a part of RoarAudio,