Index: roard/roard.c
===================================================================
--- roard/roard.c	(revision 4741)
+++ roard/roard.c	(revision 4760)
@@ -528,4 +528,12 @@
                     "RoarAudio network TCP profile"},
 #endif
+#ifdef ROAR_HAVE_IPV6
+ {"roar-tcp6",      ROAR_SOCKET_TYPE_TCP6,   ROAR_DEFAULT_PORT, ROAR_DEFAULT_INET4_HOST,
+                    ROAR_PROTO_ROARAUDIO, -1, NULL,
+                    "RoarAudio local TCP profile"},
+ {"roar-tcp-pub6",  ROAR_SOCKET_TYPE_TCP6,   ROAR_DEFAULT_PORT, ROAR_NET_INET4_ANYHOST,
+                    ROAR_PROTO_ROARAUDIO, -1, NULL,
+                    "RoarAudio network TCP profile"},
+#endif
 #ifdef ROAR_HAVE_LIBDNET
  {"roar-dnet",      ROAR_SOCKET_TYPE_DECNET, 0,                 ROAR_DEFAULT_LISTEN_OBJECT,
@@ -553,4 +561,12 @@
                     "EsounD network TCP profile"},
 #endif
+#ifdef ROAR_HAVE_IPV6
+ {"esd-tcp6",       ROAR_SOCKET_TYPE_TCP6,   ROAR_DEFAULT_ESD_PORT, ROAR_NET_INET4_LOCALHOST,
+                    ROAR_PROTO_ESOUND,    -1, NULL,
+                    "EsounD local TCP profile"},
+ {"esd-tcp-pub6",   ROAR_SOCKET_TYPE_TCP6,   ROAR_DEFAULT_ESD_PORT, ROAR_NET_INET4_ANYHOST,
+                    ROAR_PROTO_ESOUND,    -1, NULL,
+                    "EsounD network TCP profile"},
+#endif
 #endif
 
@@ -567,4 +583,12 @@
                     "RSound local TCP profile"},
  {"rsound-tcp-pub", ROAR_SOCKET_TYPE_TCP,    ROAR_DEFAULT_RSOUND_PORT, ROAR_NET_INET4_ANYHOST,
+                    ROAR_PROTO_RSOUND,    -1, NULL,
+                    "RSound network TCP profile"},
+#endif
+#ifdef ROAR_HAVE_IPV6
+ {"rsound-tcp6",    ROAR_SOCKET_TYPE_TCP6,   ROAR_DEFAULT_RSOUND_PORT, ROAR_NET_INET4_LOCALHOST,
+                    ROAR_PROTO_RSOUND,    -1, NULL,
+                    "RSound local TCP profile"},
+ {"rsound-tcp-pub6", ROAR_SOCKET_TYPE_TCP6,  ROAR_DEFAULT_RSOUND_PORT, ROAR_NET_INET4_ANYHOST,
                     ROAR_PROTO_RSOUND,    -1, NULL,
                     "RSound network TCP profile"},
@@ -587,4 +611,12 @@
                     "PulseAudio Simple TCP monitor profile"},
 #endif
+#ifdef ROAR_HAVE_IPV6
+ {"pas-play-tcp6",  ROAR_SOCKET_TYPE_TCP6,   ROAR_DEFAULT_PA_PORT, ROAR_NET_INET4_ANYHOST,
+                    ROAR_PROTO_SIMPLE, ROAR_DIR_PLAY, "default",
+                    "PulseAudio Simple TCP play profile"},
+ {"pas-mon-tcp6",   ROAR_SOCKET_TYPE_TCP6,   ROAR_DEFAULT_PA_PORT, ROAR_NET_INET4_ANYHOST,
+                    ROAR_PROTO_SIMPLE, ROAR_DIR_MONITOR, "default",
+                    "PulseAudio Simple TCP monitor profile"},
+#endif
 #endif
 
@@ -599,8 +631,17 @@
                     "RPlay network TCP profile"},
 #endif
+#ifdef ROAR_HAVE_IPV6
+ {"rplay-tcp6",     ROAR_SOCKET_TYPE_TCP6,   ROAR_DEFAULT_RPLAY_PORT, ROAR_NET_INET4_LOCALHOST,
+                    ROAR_PROTO_RPLAY,     -1, NULL,
+                    "RPlay local TCP profile"},
+ {"rplay-tcp-pub6", ROAR_SOCKET_TYPE_TCP6,   ROAR_DEFAULT_RPLAY_PORT, ROAR_NET_INET4_ANYHOST,
+                    ROAR_PROTO_RPLAY,     -1, NULL,
+                    "RPlay network TCP profile"},
+#endif
 #endif
 
 // Gopher:
 #ifndef ROAR_WITHOUT_DCOMP_EMUL_GOPHER
+#ifdef ROAR_HAVE_IPV4
  {"gopher-tcp",     ROAR_SOCKET_TYPE_TCP,    ROAR_DEFAULT_GOPHER_PORT, ROAR_NET_INET4_LOCALHOST,
                     ROAR_PROTO_GOPHER,    -1, NULL,
@@ -610,4 +651,13 @@
                     "Gopher network TCP profile"},
 #endif
+#ifdef ROAR_HAVE_IPV6
+ {"gopher-tcp6",    ROAR_SOCKET_TYPE_TCP6,   ROAR_DEFAULT_GOPHER_PORT, ROAR_NET_INET4_LOCALHOST,
+                    ROAR_PROTO_GOPHER,    -1, NULL,
+                    "Gopher local TCP profile"},
+ {"gopher-tcp-pub6", ROAR_SOCKET_TYPE_TCP6,  ROAR_DEFAULT_GOPHER_PORT, ROAR_NET_INET4_ANYHOST,
+                    ROAR_PROTO_GOPHER,    -1, NULL,
+                    "Gopher network TCP profile"},
+#endif
+#endif
 
  // End of List:
@@ -621,6 +671,6 @@
  char port[8];
 
- printf("Name           Type    Address          Port    Protocol  Dir        Audio Profile - Description\n");
- printf("------------------------------------------------------------------------------------------------\n");
+ printf("Name            Type    Address          Port    Protocol  Dir        Audio Profile - Description\n");
+ printf("-------------------------------------------------------------------------------------------------\n");
       //roar-tcp-pub 0.0.0.0       16002   RoarAudio unknown    (null) - (null)
 
@@ -630,4 +680,5 @@
    case ROAR_SOCKET_TYPE_TCP:    type = "TCP";    break;
    case ROAR_SOCKET_TYPE_DECNET: type = "DECnet"; break;
+   case ROAR_SOCKET_TYPE_TCP6:   type = "TCP6";   break;
    default:
      type = "unknown";
@@ -642,5 +693,5 @@
   }
 
-  printf("%-14s %-7s %-16s %-7s %-9s %-10s %-13s - %s\n",
+  printf("%-15s %-7s %-16s %-7s %-9s %-10s %-13s - %s\n",
            p->name,
            type,